############################################################################################################
#
# Save Programme - Custom script called from myTV 'Save Programme' menu option.
#
# Creates and sends commands to SageTV webserver
#
# 25/07/2007 - First attempt
#############################################################################################################

import sys, urllib, xbmc, xbmcgui, os, string, smb
from mytvLib import Channel, Programme, messageOK, debug, handleException
import time
from string import replace

# PRE and POST_REC_MIN's - Number of minutes to record before and after the EPG Programme times
PRE_REC_MIN = 1
POST_REC_MIN = 1

# User - pwd - ip - port
username = "change_this_to_webserver_user"
password = "change_this_to_webserver_pwd"
IP = "change_this_to_webserver_IP"
port = "change_this_to_webserver_port"


progressBar = xbmcgui.DialogProgress()
try: Emulating = xbmcgui.Emulating
except: Emulating = False

################################################################################################
#                                                                                              #
#                                                                                              #
################################################################################################
class SaveProgramme:
	def __init__(self, cachePath=""):

		self.xml = XMLGetter()
		self.BASE_URL = "http://" + username + ":" + password + "@" + IP + ":" + port + "/sage/"


	def run(self, channel, programme, confirmRequired=True):
		debug("> SaveProgramme().run()")
		returnStr = ''

		pid = programme.getLink()

		debug("record prog")

		record_string = self.BASE_URL + 'Manualrecord?command=Record&AiringId=' + pid

		if record_string:
			resultStr = self.xml.get(record_string)
			if len(resultStr) > 0:
				if confirmRequired:
					messageOK('Save Programme','Program Saved Succesfully.')
			else:
				messageOK('Save Programme Failed','No response from server.')


		debug("< SaveProgramme.run()")
		return returnStr


class XMLGetter:
	def get(self, url):
		debug("> XMLGetter().get() url=" + url)
		xml = ''

		progressBar.create("Downloading XML Data...","Please wait ...")
		trys = 0
		opener = urllib.FancyURLopener({})
		while (trys < 2):
			try:
				doc = opener.open(url)
				opener.close()
			except:
				trys += 1
			else:
				xml = doc.read()
				break	# stop loop

		progressBar.close()

		if not xml:
			messageOK("XML Fetch Error","Failed Connecting to host:",url)
		debug("< XMLGetter().get()")
		return xml
